"""
Surface interfaces for the implementation modules:

 * :py:mod:`traffic.libkqueue`
"""
import importlib
import functools
from .protocol import *

#: Dictionary whose values refer to callables importing the Traffic implementation
#: described by the key.
implementation = {
	'kqueue': functools.partial(importlib.import_module, '.libkqueue', package = __package__)
}
