/*
 * xerrno.h - detect the set of errno available.
 * libkqueue wants to provide the macro's name with Status objects,
 * but without leaning on the errno module.
 *
 * Get a list from OpenGroup's POSIX specification.
 */
#ifdef _WIN32
#endif

/*
 * Errno Not Defined.
 */
#define XENOTDEFINED -0xDEADBEEF

#ifndef XESUCCESS
#define XESUCCESS 0
#endif

#ifndef E2BIG
#define E2BIG XENOTDEFINED
#endif
#ifndef EACCES
#define EACCES XENOTDEFINED
#endif
#ifndef EADDRINUSE
#define EADDRINUSE XENOTDEFINED
#endif
#ifndef EADDRNOTAVAIL
#define EADDRNOTAVAIL XENOTDEFINED
#endif
#ifndef EAFNOSUPPORT
#define EAFNOSUPPORT XENOTDEFINED
#endif
#ifndef EAGAIN
#define EAGAIN XENOTDEFINED
#endif
#ifndef EALREADY
#define EALREADY XENOTDEFINED
#endif
#ifndef EBADF
#define EBADF XENOTDEFINED
#endif
#ifndef EBADMSG
#define EBADMSG XENOTDEFINED
#endif
#ifndef EBUSY
#define EBUSY XENOTDEFINED
#endif
#ifndef ECANCELED
#define ECANCELED XENOTDEFINED
#endif
#ifndef ECHILD
#define ECHILD XENOTDEFINED
#endif
#ifndef ECONNABORTED
#define ECONNABORTED XENOTDEFINED
#endif
#ifndef ECONNREFUSED
#define ECONNREFUSED XENOTDEFINED
#endif
#ifndef ECONNRESET
#define ECONNRESET XENOTDEFINED
#endif
#ifndef EDEADLK
#define EDEADLK XENOTDEFINED
#endif
#ifndef EDESTADDRREQ
#define EDESTADDRREQ XENOTDEFINED
#endif
#ifndef EDOM
#define EDOM XENOTDEFINED
#endif
#ifndef EDQUOT
#define EDQUOT XENOTDEFINED
#endif
#ifndef EEXIST
#define EEXIST XENOTDEFINED
#endif
#ifndef EFAULT
#define EFAULT XENOTDEFINED
#endif
#ifndef EFBIG
#define EFBIG XENOTDEFINED
#endif
#ifndef EHOSTUNREACH
#define EHOSTUNREACH XENOTDEFINED
#endif
#ifndef EIDRM
#define EIDRM XENOTDEFINED
#endif
#ifndef EILSEQ
#define EILSEQ XENOTDEFINED
#endif
#ifndef EINPROGRESS
#define EINPROGRESS XENOTDEFINED
#endif
#ifndef EINTR
#define EINTR XENOTDEFINED
#endif
#ifndef EINVAL
#define EINVAL XENOTDEFINED
#endif
#ifndef EIO
#define EIO XENOTDEFINED
#endif
#ifndef EISCONN
#define EISCONN XENOTDEFINED
#endif
#ifndef EISDIR
#define EISDIR XENOTDEFINED
#endif
#ifndef ELOOP
#define ELOOP XENOTDEFINED
#endif
#ifndef EMFILE
#define EMFILE XENOTDEFINED
#endif
#ifndef EMLINK
#define EMLINK XENOTDEFINED
#endif
#ifndef EMSGSIZE
#define EMSGSIZE XENOTDEFINED
#endif
#ifndef EMULTIHOP
#define EMULTIHOP XENOTDEFINED
#endif
#ifndef ENAMETOOLONG
#define ENAMETOOLONG XENOTDEFINED
#endif
#ifndef ENETDOWN
#define ENETDOWN XENOTDEFINED
#endif
#ifndef ENETRESET
#define ENETRESET XENOTDEFINED
#endif
#ifndef ENETUNREACH
#define ENETUNREACH XENOTDEFINED
#endif
#ifndef ENFILE
#define ENFILE XENOTDEFINED
#endif
#ifndef ENOBUFS
#define ENOBUFS XENOTDEFINED
#endif
#ifndef ENODATA
#define ENODATA XENOTDEFINED
#endif
#ifndef ENODEV
#define ENODEV XENOTDEFINED
#endif
#ifndef ENOENT
#define ENOENT XENOTDEFINED
#endif
#ifndef ENOEXEC
#define ENOEXEC XENOTDEFINED
#endif
#ifndef ENOLCK
#define ENOLCK XENOTDEFINED
#endif
#ifndef ENOLINK
#define ENOLINK XENOTDEFINED
#endif
#ifndef ENOMEM
#define ENOMEM XENOTDEFINED
#endif
#ifndef ENOMSG
#define ENOMSG XENOTDEFINED
#endif
#ifndef ENOPROTOOPT
#define ENOPROTOOPT XENOTDEFINED
#endif
#ifndef ENOSPC
#define ENOSPC XENOTDEFINED
#endif
#ifndef ENOSR
#define ENOSR XENOTDEFINED
#endif
#ifndef ENOSTR
#define ENOSTR XENOTDEFINED
#endif
#ifndef ENOSYS
#define ENOSYS XENOTDEFINED
#endif
#ifndef ENOTCONN
#define ENOTCONN XENOTDEFINED
#endif
#ifndef ENOTDIR
#define ENOTDIR XENOTDEFINED
#endif
#ifndef ENOTEMPTY
#define ENOTEMPTY XENOTDEFINED
#endif
#ifndef ENOTSOCK
#define ENOTSOCK XENOTDEFINED
#endif
#ifndef ENOTSUP
#define ENOTSUP XENOTDEFINED
#endif
#ifndef ENOTTY
#define ENOTTY XENOTDEFINED
#endif
#ifndef ENXIO
#define ENXIO XENOTDEFINED
#endif
#ifndef EOPNOTSUPP
#define EOPNOTSUPP XENOTDEFINED
#endif
#ifndef EOVERFLOW
#define EOVERFLOW XENOTDEFINED
#endif
#ifndef EPERM
#define EPERM XENOTDEFINED
#endif
#ifndef EPIPE
#define EPIPE XENOTDEFINED
#endif
#ifndef EPROTO
#define EPROTO XENOTDEFINED
#endif
#ifndef EPROTONOSUPPORT
#define EPROTONOSUPPORT XENOTDEFINED
#endif
#ifndef EPROTOTYPE
#define EPROTOTYPE XENOTDEFINED
#endif
#ifndef ERANGE
#define ERANGE XENOTDEFINED
#endif
#ifndef EROFS
#define EROFS XENOTDEFINED
#endif
#ifndef ESPIPE
#define ESPIPE XENOTDEFINED
#endif
#ifndef ESRCH
#define ESRCH XENOTDEFINED
#endif
#ifndef ESTALE
#define ESTALE XENOTDEFINED
#endif
#ifndef ETIME
#define ETIME XENOTDEFINED
#endif
#ifndef ETIMEDOUT
#define ETIMEDOUT XENOTDEFINED
#endif
#ifndef ETXTBSY
#define ETXTBSY XENOTDEFINED
#endif
#ifndef EWOULDBLOCK
#define EWOULDBLOCK XENOTDEFINED
#endif
#ifndef EXDEV
#define EXDEV XENOTDEFINED
#endif

/*
 * strerror will be used, but include the posix description as well.
 */
#define _XERRNO() \
XDEF(E2BIG, "Argument list too long.") \
XDEF(EACCES, "Permission denied.") \
XDEF(EADDRINUSE, "Address in use.") \
XDEF(EADDRNOTAVAIL, "Address not available.") \
XDEF(EAFNOSUPPORT, "Address family not supported.") \
XDEF(EAGAIN, "Resource unavailable, try again.") \
XDEF(EALREADY, "Connection already in progress.") \
XDEF(EBADF, "Bad file descriptor.") \
XDEF(EBADMSG, "Bad message.") \
XDEF(EBUSY, "Device or resource busy.") \
XDEF(ECANCELED, "Operation canceled.") \
XDEF(ECHILD, "No child processes.") \
XDEF(ECONNABORTED, "Connection aborted.") \
XDEF(ECONNREFUSED, "Connection refused.") \
XDEF(ECONNRESET, "Connection reset.") \
XDEF(EDEADLK, "Resource deadlock would occur.") \
XDEF(EDESTADDRREQ, "Destination address required.") \
XDEF(EDOM, "Mathematics argument out of domain of function.") \
XDEF(EDQUOT, "Reserved.") \
XDEF(EEXIST, "File exists.") \
XDEF(EFAULT, "Bad address.") \
XDEF(EFBIG, "File too large.") \
XDEF(EHOSTUNREACH, "Host is unreachable.") \
XDEF(EIDRM, "Identifier removed.") \
XDEF(EILSEQ, "Illegal byte sequence.") \
XDEF(EINPROGRESS, "Operation in progress.") \
XDEF(EINTR, "Interrupted function.") \
XDEF(EINVAL, "Invalid argument.") \
XDEF(EIO, "I/O error.") \
XDEF(EISCONN, "Socket is connected.") \
XDEF(EISDIR, "Is a directory.") \
XDEF(ELOOP, "Too many levels of symbolic links.") \
XDEF(EMFILE, "Too many open files.") \
XDEF(EMLINK, "Too many links.") \
XDEF(EMSGSIZE, "Message too large.") \
XDEF(EMULTIHOP, "Reserved.") \
XDEF(ENAMETOOLONG, "Filename too long.") \
XDEF(ENETDOWN, "Network is down.") \
XDEF(ENETRESET, "Connection aborted by network.") \
XDEF(ENETUNREACH, "Network unreachable.") \
XDEF(ENFILE, "Too many files open in system.") \
XDEF(ENOBUFS, "No buffer space available.") \
XDEF(ENODATA, "No message is available on the STREAM head read queue.") \
XDEF(ENODEV, "No such device.") \
XDEF(ENOENT, "No such file or directory.") \
XDEF(ENOEXEC, "Executable file format error.") \
XDEF(ENOLCK, "No locks available.") \
XDEF(ENOLINK, "Reserved.") \
XDEF(ENOMEM, "Not enough space.") \
XDEF(ENOMSG, "No message of the desired type.") \
XDEF(ENOPROTOOPT, "Protocol not available.") \
XDEF(ENOSPC, "No space left on device.") \
XDEF(ENOSR, "No STREAM resources.") \
XDEF(ENOSTR, "Not a STREAM.") \
XDEF(ENOSYS, "Function not supported.") \
XDEF(ENOTCONN, "The socket is not connected.") \
XDEF(ENOTDIR, "Not a directory.") \
XDEF(ENOTEMPTY, "Directory not empty.") \
XDEF(ENOTSOCK, "Not a socket.") \
XDEF(ENOTSUP, "Not supported.") \
XDEF(ENOTTY, "Inappropriate I/O control operation.") \
XDEF(ENXIO, "No such device or address.") \
XDEF(EOPNOTSUPP, "Operation not supported on socket.") \
XDEF(EOVERFLOW, "Value too large to be stored in data type.") \
XDEF(EPERM, "Operation not permitted.") \
XDEF(EPIPE, "Broken pipe.") \
XDEF(EPROTO, "Protocol error.") \
XDEF(EPROTONOSUPPORT, "Protocol not supported.") \
XDEF(EPROTOTYPE, "Protocol wrong type for socket.") \
XDEF(ERANGE, "Result too large.") \
XDEF(EROFS, "Read-only file system.") \
XDEF(ESPIPE, "Invalid seek.") \
XDEF(ESRCH, "No such process.") \
XDEF(ESTALE, "Reserved.") \
XDEF(ETIME, "Stream ioctl() timeout.") \
XDEF(ETIMEDOUT, "Connection timed out.") \
XDEF(ETXTBSY, "Text file busy.") \
XDEF(EXDEV, "Cross-device link.") \
\
XDEF(XESUCCESS, "No error occurred.") \
XDEF(XENOTDEFINED, "Error number was not defined in \"sys/errno.h\".")

#if EWOULDBLOCK != EAGAIN
#define XERRNO() \
XDEF(EWOULDBLOCK, "Operation would block (may be the same value as EAGAIN).") \
_XERRNO()
#else
/*
 * EWOULDBLOCK == EAGAIN, so use EAGAIN
 */
#define XERRNO() _XERRNO()
#endif

/*
 * vim: ts=3:sw=3:noet:
 */
